---
title: Using channel messaging
slug: Web/API/Channel_Messaging_API/Using_channel_messaging
tags:
  - API
  - Channel messaging
  - HTML5
  - MessageChannel
  - MessagePort
  - Tutorial
---
<p>{{DefaultAPISidebar("Channel Messaging API")}}</p>

<p><span class="seoSummary">The <a href="/en-US/docs/Web/API/Channel_Messaging_API">Channel Messaging API</a> allows two separate scripts running in different browsing contexts attached to the same document (e.g., two IFrames, or the main document and an IFrame, or two documents via a {{domxref("SharedWorker")}}) to communicate directly, passing messages between one another through two-way channels (or pipes) with a port at each end.</span></p>

<p>In this article we'll explore the basics of using this technology.</p>

<p>{{AvailableInWorkers}}</p>

<h2 id="Use_cases">Use cases</h2>

<p>Channel messaging is mainly useful in cases where you've got a social site that embeds capabilities from other sites into its main interface via IFrames, such as games, address book, or an audio player with personalized music choices. When these act as standalone units, things are ok, but the difficulty comes when you want interaction between the main site and the IFrames, or the different IFrames. For example, what if you wanted to add a contact to the address book from the main site, add high scores from your game into your main profile, or add new background music choices from the audio player onto the game? Such things are not so easy using conventional web technology, because of the security models the web uses. You have to think about whether the origins trust one another, and how the messages are passed.</p>

<p>Message channels on the other hand can provide a secure channel that allows you to pass data between different browsing contexts. </p>

<div class="note">
<p><strong>Note</strong>: For more information and ideas, the <a href="https://html.spec.whatwg.org/multipage/comms.html#ports-as-the-basis-of-an-object-capability-model-on-the-web">Ports as the basis of an object-capability model on the Web</a> section of the spec is a useful read.</p>
</div>

<h2 id="Simple_examples">Simple examples</h2>

<p>To get your started, we have published a couple of demos on Github. First up, check out our <a href="https://github.com/mdn/dom-examples/tree/master/channel-messaging-basic">channel messaging basic demo</a> (<a href="https://mdn.github.io/dom-examples/channel-messaging-basic/">run it live too</a>), which shows a really simple single message transfer between a page and an embedded {{htmlelement("iframe")}}.</p>

<p>Secondly, have a look at our <a href="https://github.com/mdn/dom-examples/tree/master/channel-messaging-multimessage">multimessaging demo</a> (<a href="https://mdn.github.io/dom-examples/channel-messaging-multimessage/">run this live</a>), which shows a slightly more complex setup that can send multiple messages between the main page and an IFrame.</p>

<p>We'll be focusing on the latter example in this article. It looks like so:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/10075/channel-messaging-demo.png" style="display: block; height: 744px; margin: 0px auto; width: 690px;"></p>

<h2 id="Creating_the_channel">Creating the channel</h2>

<p>In the main page of the demo, we have a simple form with a text input for entering messages to be sent to an {{htmlelement("iframe")}}. We also have a paragraph which we will use later on to display confirmation messages that we will receive back from the {{htmlelement("iframe")}}.</p>

<pre class="brush: js notranslate">var input = document.getElementById('message-input');
var output = document.getElementById('message-output');
var button = document.querySelector('button');
var iframe = document.querySelector('iframe');

var channel = new MessageChannel();
var port1 = channel.port1;

// Wait for the iframe to load
iframe.addEventListener("load", onLoad);

function onLoad() {
  // Listen for button clicks
  button.addEventListener('click', onClick);

  // Listen for messages on port1
  port1.onmessage = onMessage;

  // Transfer port2 to the iframe
  iframe.contentWindow.postMessage('init', '*', [channel.port2]);
}

// Post a message on port1 when the button is clicked
function onClick(e) {
  e.preventDefault();
  port1.postMessage(input.value);
}

// Handle messages received on port1
function onMessage(e) {
  output.innerHTML = e.data;
  input.value = '';
}</pre>

<p>We start off by creating a new message channel by using the {{domxref( "MessageChannel.MessageChannel","MessageChannel()")}} constructor.</p>

<p>When the IFrame has loaded, we register an <code>onclick</code> handler for our button and an <code>onmessage</code> handler for {{domxref("MessageChannel.port1")}}. Finally we transfer {{domxref("MessageChannel.port2")}} to the IFrame using the {{domxref("window.postMessage")}} method.</p>

<p>Let's explore how the <code>iframe.contentWindow.postMessage</code> line works in a bit more detail. It takes three arguments:</p>

<ol>
 <li>The message being sent. For this initial port transfering this message could be an empty string but in this example it is set to <code>'init'</code>.</li>
 <li>The origin the message is to be sent to. <code>*</code> means "any origin".</li>
 <li>An object, the ownership of which is transferred to the receiving browsing context. In this case, we are transferring {{domxref("MessageChannel.port2")}} to the IFrame, so it can be used to communicate with the main page.</li>
</ol>

<p>When our button is clicked, we prevent the form from submitting as normal and then send the value entered in our text input to the IFrame via the {{domxref("MessageChannel")}}.</p>

<h2 id="Receiving_the_port_and_message_in_the_IFrame">Receiving the port and message in the IFrame</h2>

<p>Over in the IFrame, we have the following JavaScript:</p>

<pre class="brush: js notranslate">var list = document.querySelector('ul');
var port2;

// Listen for the initial port transfer message
window.addEventListener('message', initPort);

// Setup the transferred port
function initPort(e) {
  port2 = e.ports[0];
  port2.onmessage = onMessage;
}

// Handle messages received on port2
function onMessage(e) {
  var listItem = document.createElement('li');
  listItem.textContent = e.data;
  list.appendChild(listItem);
  port2.postMessage('Message received by IFrame: "' + e.data + '"');
}
</pre>

<p>When the initial message is received from the main page via the {{domxref("window.postMessage")}} method, we run the <code>initPort</code> function. This saves the transferred port and register an <font face="consolas, Liberation Mono, courier, monospace"><span style="background-color: rgba(220, 220, 220, 0.5);">onmessage</span></font> handler that will be called each time a message is passed through our {{domxref("MessageChannel")}}.</p>

<p>When a message is received from the main page we create a list item and insert it in the unordered list, setting the {{domxref("Node.textContent","textContent")}} of the list item equal to the event's <code>data</code> attribute (this contains the actual message).</p>

<p>Next, we post a confirmation message back to the main page via the message channel by calling {{domxref("MessagePort.postMessage")}} on {{domxref("MessageChannel.port2")}} that was initially transferred to the IFrame. </p>

<h2 id="Receiving_the_confirmation_in_the_main_page">Receiving the confirmation in the main page</h2>

<p>Returning to the main page, let's now look at the onmessage handler function.</p>

<pre class="brush: js notranslate">// Handle messages received on port1
function onMessage(e) {
  output.innerHTML = e.data;
  input.value = '';
}</pre>

<p>When a message is received back from the IFrame confirming that the original message was received successfully, this outputs the confirmation to a paragraph and empties the text input ready for the next message to be sent.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', 'web-messaging.html#channel-messaging', 'Channel messaging')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<h3 id="MessageChannel"><code>MessageChannel</code></h3>

<p>{{Compat("api.MessageChannel", 0)}}</p>

<h3 id="MessagePort"><code>MessagePort</code></h3>

<div class="hidden">The compatibility table on this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</div>

<p>{{Compat("api.MessagePort", 0)}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Channel_Messaging_API">Channel Messaging API</a></li>
 <li><a href="/en-US/docs/Web/API/Web_Workers_API">Web Workers API</a></li>
 <li><a href="/en-US/docs/Web/API/Broadcast_Channel_API">Broadcast Channel API</a></li>
</ul>
